#ifndef _3D_SHAPE_CONTROL_MATRIX_
#define _3D_SHAPE_CONTROL_MATRIX_

#include "local_basic_type.h"

/*=================================================================================================
  Macro definition
 ================================================================================================*/
/* matrix 01 inputs event  */
enum{
	EVENT_SYSTEM_MODE_CAMERA = 0    ,	/**< 0 Camera mode inputs           */
	EVENT_SYSTEM_MODE_CAPTURE       ,	/**< 1 Capture mode inputs          */
	EVENT_SYSTEM_MODE_CLOUD         ,	/**< 2 Cloud mode inputs            */
	EVENT_SYSTEM_MODE_STORED_DATA   ,	/**< 3 Stored data mode inputs      */
	EVENT_PLAY_MODE_PLAY            ,	/**< 4 Play mode inputs             */
	EVENT_PLAY_MODE_STOP            ,	/**< 5 Stop mode inputs             */
	EVENT_MTX01_MAX                 ,	/**< 6 MAX                          */
};

/* matrix 01 mode          */
enum{
	MTX_MODE_CAM = 0 								,	/**< 0 System mode = Camera         */
	MTX_MODE_CAP     								,	/**< 1 System mode = Capture        */
	MTX_MODE_CLD     								,	/**< 2 System mode = Cloud          */
	MTX_MODE_STD     								,	/**< 3 System mode = Stored         */
	MTX_01_MODE_MAX       					,	/**< 4 matrix 01 mode max           */
};

/* matrix 02 inputs event  */
enum{
	EVENT_INPUT_IMAGE_CAMERA = 0    ,	/**< 0 Camera image inputs          */
	EVENT_INPUT_IMAGE_CAPTURE       ,	/**< 1 Capture image inputs         */
	EVENT_INPUT_IMAGE_CLOUD         ,	/**< 2 Cloud image inputs           */
	EVENT_3D_IMAGE_CREATED_COMPLETE ,	/**< 3 3D image creation completion */
	EVENT_3D_IMAGE_CREATED_ERROR    ,	/**< 4 3D image creation error      */
	EVENT_MTX02_MAX                 ,	/**< 5 MAX                          */
};

/* matrix 02 mode          */
enum{
	MTX_IMAGE_UNCREATED = 0   			,	/**< 0 3D Image creating            */
	MTX_IMAGE_CREATING        			,	/**< 1 Not created 3D image         */
	MTX_02_MODE_MAX           			,	/**< 2 matrix 02 mode max           */
};

#define	MTX_02_MODE_MIN     MTX_IMAGE_UNCREATED
#define	NO_STATE_CHG        (0xFFFFu) /**< 255 No state change          */

/* 3D Shape Control mode Process          */
enum{
	PROC_NO_STATUS_CHG_MODE = 0                        ,	/**<  0	No status change of mode	                            */
	PROC_CHG_STATUS_CAMERA                             ,	/**<  1	Status change to camera                               */
	PROC_CHG_STATUS_CAPTURE                            ,	/**<  2	Status change to capture                              */
	PROC_CHG_STATUS_CLOUD                              ,	/**<  3	Status change to cloud                                */
	PROC_CHG_STATUS_STORED                             ,	/**<  4	Status change to stored data                          */
	PROC_3D_IMG_CREATE_ENABLE                          ,	/**<  5	3D images creation enable by means of mode	          */
	PROC_3D_IMG_CREATE_DISABLE                         ,	/**<  6	3D images creation disable by means of mode	          */
	PROC_MTX01_SIZE_MAX                                ,	/**<  7	Nothing                                               */
};

/* 3D Shape Control create Process        */
enum{
	PROC_3D_IMAGE_CREATE_CAMERA = PROC_MTX01_SIZE_MAX  ,	/**<  7	Judge the start of image creation by means of Camera	*/
	PROC_3D_IMAGE_CREATE_CAPTURE                       ,	/**<  8	Judge the start of image creation by means of Capture	*/
	PROC_3D_IMAGE_CREATE_CLOUD                         ,	/**<  9	Judge the start of image creation by means of Cloud	  */
	PROC_3D_IMAGE_CREATE_RES_JUDGE                     ,	/**< 10	Judge the result of image creation	                  */
	PROC_3D_IMAGE_CREATE_ERR_JUDGE                     ,	/**< 11	Judge the error of image creation                     */
	PROC_3D_IMAGE_BACKUP_CAPTURE                       ,	/**< 12	Back up the image of capture                          */
	PROC_3D_IMAGE_BACKUP_CLOUD                         ,	/**< 13	Back up the image of cloud                            */
	PROC_MTX02_SIZE_MAX                                ,	/**< 14	Nothing                                               */
};

#define PROC_SIZE_MIN             PROC_NO_STATUS_CHG_MODE
#define PROC_SIZE_MAX             PROC_MTX02_SIZE_MAX

#define	NO_PROC                   (0xFFFFu)           /**< 255	No Proc      */

#define	NO_EVENT_INIT             (0xFFFFu)
#define CASE_MTX01                (0)                 /**< Case Mode         */
#define CASE_MTX02                (1)                 /**< Case Create       */

#define MTX_MODE_CAMERA           (0)
#define MTX_MODE_CAPTUR           (1)
#define MTX_MODE_DCLOUD           (2)
#define MTX_MODE_STORED           (3)
#define MTX_MODE_DATA_OF_MAX      (MTX_MODE_STORED + 1)

#endif
